CoCoA-5 - Feature #823

NewPolyRing with weights -- better interface?
26 Nov 2015 11:16 - John Abbott

Status: Closed Start date: 26 Nov 2015
Priority: Normal Due date:

Assignee: Anna Maria Bigatti % Done: 100%
Category: enhancing/improving Estimated time: 2.01 hours
Target version: CoCoA-5.4.2 Spent time: 1.70 hour
Description

According to the C5 manual, if we want to create a new poly ring with given weights then we must supply a complete order matrix,
and also say how many rows contribute to the weights (the "grading dim").

The examples in src/CoCoA-5/tests/lecture-HF 1.cocoa5 which use this feature all seem to be of the form:

wts := mat (/*weights matrix*/);

P := NewPolyRing(QQ, indets, CompleteToOrd(wts), NumRows (wts));

Would it not be simpler and clearer to allow the following input:

wts := mat (/*weights matrix*/);
P := NewPolyRing(QQ, indets, wts);

perhaps wts could even be just a list of lists of integers? (though the conversion to a matrix automatically verifies that each row has
the same length).

2024-03 new function name: NewPolyRingWeights(QQ,"x,y", W);

Related issues:

Related to CoCoA-5 - Feature #1747: NewPolyRing with indices -- better interf... New 29 Jun 2023
Related to CoCoALib - Bug #1789: GradingMat with negative weights should com... Closed 12 Mar 2024
Related to CoCoALib - Design #832: Generalize grading matrix New 04 Dec 2015
History

#1 - 26 Nov 2015 11:20 - John Abbott
- Category set to enhancing/improving

- Target version set to COCoA-5.72.7
An alternative would be to accept a record as an argument, but this does make the input longer: for instance
wts := /*weights*/;

P := NewPolyRing (QQ, indets, record[weights := wts]);

This approach has the advantage that whoever reads the code understands immediately the role of the 3rd arg (though an astute choice of variable
name would probably do this too).

Comments? Opinions? ldeas?
#2 - 29 Jun 2023 17:51 - John Abbott
- Target version changed from CoCoA-5.?.7 to CoCoA-5.4.4

It would be good to offer an easier way to specify name ranges:
The following does not currently work:

NewPolyRing (QQ, "x[1..4],y[1..41", W, 2);

It is much more cumbersome having to write something like this:

concat (SymbolRange ("x",1,4), SymbolRange("y",1,4))

Also it would be handy being able to specify just the weights (with implicit grading dim), and let NewPolyRing complete the term ordering (somehow,
presumably RevLex). Perhaps there should be two similar but different names? OSCAR is easier than CoCoA!

#3 - 29 Jun 2023 18:05 - Anna Maria Bigatti
John Abbott wrote:

It would be good to offer an easier way to specify name ranges:
The following does not currently work:

x[1..4],y[1..4] would be quite nice in cocoalib as well ;-)
a bit of parsing needed.
Follow in new issue (so we don't mix up quite different topics) ----> #1747

It is much more cumbersome having to write something like this:

[..]

P := NewPolyRing(QQ, indets, wts);
would be trivial to do and nice to use.
| cannot see any drawbacks in it.

what about
https://cocoa.dima.unige.it/redmine/issues/1747

#4 - 29 Jun 2023 18:05 - Anna Maria Bigatti
- Status changed from New to In Progress

- % Done changed from 0 to 20

#5 - 29 Jun 2023 18:08 - Anna Maria Bigatti
- Related to Feature #1747: NewPolyRing with indices -- better interface? added

#6 - 22 Dec 2023 10:43 - Anna Maria Bigatti
John Abbott wrote:

An alternative would be to accept a record as an argument, but this does make the input longer: for instance

(-]

This approach has the advantage that whoever reads the code understands immediately the role of the 3rd arg (though an astute choice of
variable name would probably do this too).

| think it would easier to implement, use and document, to have NewPolyRingWeights (which should just call NewPolyRing as we do now)

#7 - 22 Dec 2023 11:29 - John Abbott

[after phone discussion]
Might the name NewPolyRingWithWeights be clearer?
Anyway, we can always later change the name, and make the old one obsolescent.

#8 - 14 Mar 2024 08:55 - Anna Maria Bigatti
- Related to Bug #1789: GradingMat with negative weights should complain (or deal with them properly!!) added

#9 - 14 Mar 2024 09:54 - Anna Maria Bigatti

- Assignee set to Anna Maria Bigatti

- Target version changed from CoCoA-5.4.4 to CoCoA-5.4.2
- % Done changed from 20 to 70

#10 - 14 Mar 2024 11:22 - Anna Maria Bigatti
- Related to Design #832: Generalize grading matrix added

#11 - 15 Mar 2024 15:40 - Anna Maria Bigatti

- Description updated
See #1789-10
#12 - 18 Mar 2024 16:17 - Anna Maria Bigatti

- Description updated

- Status changed from In Progress to Closed
https://cocoa.dima.unige.it/redmine/issues/1789#note-10

- % Done changed from 70 to 100

#13 - 18 Mar 2024 17:02 - Anna Maria Bigatti
- Estimated time set to 2.01 h

Added example in ex-PolyRing2.C

#14 - 18 Mar 2024 21:39 - John Abbott

| did slightly prefer the name | suggested in note 7 (but it is longer).
Anyway, this is a good improvement to the interface: easy-to-use correctly, and unlikely to be used wrongly.
